"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Controls = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _visualAnalyticsComponents = require("visual-analytics-components");

var _Dropdown = require("./Dropdown");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\tdisplay: flex;\n\tflex-direction: row;\n\tmin-height: 25px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SLICE_OPTIONS = [{
  value: _visualAnalyticsComponents.SliceType.All,
  name: 'All'
}, {
  value: _visualAnalyticsComponents.SliceType.FilteredIn,
  name: 'Filtered-In'
}, {
  value: _visualAnalyticsComponents.SliceType.FilteredOut,
  name: 'Filtered-Out'
}, {
  value: _visualAnalyticsComponents.SliceType.Selected,
  name: 'Selected'
}, {
  value: _visualAnalyticsComponents.SliceType.Highlighted,
  name: 'Highlighted'
}];
var SLICE_VALUES = SLICE_OPTIONS.map(function (s) {
  return s.value;
});
var SLICE_LABELS = SLICE_OPTIONS.map(function (s) {
  return s.name;
});
var Controls = (0, React.memo)(function Controls(_ref) {
  var tableNames = _ref.tableNames,
      table = _ref.table,
      slice = _ref.slice,
      onTableChanged = _ref.onTableChanged,
      onSliceChanged = _ref.onSliceChanged;
  return React.createElement(ControlsContainer, null, React.createElement(_Dropdown.Dropdown, {
    options: tableNames,
    value: table,
    onChange: onTableChanged
  }), React.createElement(_Dropdown.Dropdown, {
    options: SLICE_VALUES,
    labels: SLICE_LABELS,
    value: slice,
    onChange: onSliceChanged
  }));
});
exports.Controls = Controls;

var ControlsContainer = _styledComponents.default.div(_templateObject());