"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Datatable = void 0;

var React = _interopRequireWildcard(require("react"));

var _operators = require("rxjs/operators");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _visualAnalyticsComponents = require("visual-analytics-components");

var _AgFilterStore = require("../util/AgFilterStore");

var _Controls = require("./Controls");

var _GlobalStyles = require("./GlobalStyles");

var _Grid = require("./Grid");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\twidth: 100%;\n\theight: 100%;\n\tdisplay: flex;\n\tflex-direction: column;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Datatable = (0, React.memo)(function Datatable(_ref) {
  var manager = _ref.manager;
  var tableNames = useTableNames(manager);
  var store = (0, React.useMemo)(function () {
    return new _AgFilterStore.AgFilterStore();
  }, []);

  var _useState = (0, React.useState)(_visualAnalyticsComponents.SliceType.FilteredIn),
      _useState2 = _slicedToArray(_useState, 2),
      slice = _useState2[0],
      setSlice = _useState2[1];

  var _useState3 = (0, React.useState)(tableNames[0]),
      _useState4 = _slicedToArray(_useState3, 2),
      table = _useState4[0],
      setTable = _useState4[1];

  var filterLocation = (0, React.useMemo)(function () {
    return {
      table: table,
      key: 'datatable'
    };
  }, [table]);
  var dataTable = useTable(manager, table);
  var dataSlice = (0, React.useMemo)(function () {
    return dataTable.slice(slice);
  }, [dataTable, slice]);

  var _useState5 = (0, React.useState)(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      dataVersion = _useState6[0],
      setDataVersion = _useState6[1];

  var _useState7 = (0, React.useState)(function () {
    return dataTable.slice(slice).filter.expressions['datatable'];
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      filterExpression = _useState8[0],
      setFilterExpression = _useState8[1];

  var onFilterChanged = (0, React.useCallback)(function (expr, agExpr) {
    if (expr) {
      store.setFilter(table, slice, agExpr);
      setFilterExpression(expr);
      manager.publish(_visualAnalyticsComponents.MessageCreators.Filter.replace(filterLocation, expr, 'Apply Data Filter'));
    } else {
      store.clearFilter(table, slice);
      manager.publish(_visualAnalyticsComponents.MessageCreators.Filter.clear(filterLocation, 'Clear Data Filter'));
    }
  }, [filterLocation, manager, slice, store, table]);
  var handleTableChanged = (0, React.useCallback)(function (tableName) {
    console.log('set table', tableName);
    setTable(tableName);
  }, []);
  var handleSliceChanged = (0, React.useCallback)(function (slice) {
    return setSlice(slice);
  }, []);
  var isDataChangeEvent = (0, React.useCallback)(function (evt) {
    return evt.type === _visualAnalyticsComponents.MessageTypes.Data.Changed && evt.payload.table === table && evt.payload.slice === slice;
  }, [table, slice]);
  (0, React.useEffect)(function () {
    var subscription = manager.messages.pipe((0, _operators.filter)(isDataChangeEvent)).subscribe(function (evt) {
      setFilterExpression(dataTable.slice(slice).filter.expressions['datatable']);
      setDataVersion(evt);
    });
    return function () {
      return subscription.unsubscribe();
    };
  }, [manager, isDataChangeEvent, dataTable, slice]);
  return React.createElement(React.Fragment, null, React.createElement(_GlobalStyles.GlobalStyles, null), React.createElement(Container, null, React.createElement(_Controls.Controls, {
    tableNames: tableNames,
    table: table,
    slice: slice,
    onTableChanged: handleTableChanged,
    onSliceChanged: handleSliceChanged
  }), React.createElement(_Grid.Grid, {
    filterExpression: filterExpression,
    agFilterExpression: store.getFilter(table, slice),
    dataVersion: dataVersion,
    columns: dataTable.columns,
    slice: dataSlice,
    onFilterChanged: onFilterChanged
  })));
});
exports.Datatable = Datatable;

function useTableNames(manager) {
  return (0, React.useMemo)(function () {
    return manager.data.tables;
  }, [manager]);
}

function useTable(manager, name) {
  return (0, React.useMemo)(function () {
    return manager.data.table(name);
  }, [manager, name]);
}

var Container = _styledComponents.default.div(_templateObject());