"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Grid = void 0;

var _agGridReact = require("ag-grid-react");

var _lodash = require("lodash");

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _TableDataSource = require("../TableDataSource");

var _ag_translate = require("../util/ag_translate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n\theight: 100%;\n\twidth: 100%;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\tflex: 1;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function isEmptyFilter(agFilter) {
  return !agFilter || Object.keys(agFilter).length === 0;
}

var Grid = (0, React.memo)(function Grid(_ref) {
  var slice = _ref.slice,
      columns = _ref.columns,
      filterExpression = _ref.filterExpression,
      agFilterExpression = _ref.agFilterExpression,
      onFilterChanged = _ref.onFilterChanged;

  var _useState = (0, React.useState)(undefined),
      _useState2 = _slicedToArray(_useState, 2),
      api = _useState2[0],
      setApi = _useState2[1];

  var rowData = (0, React.useMemo)(function () {
    return new _TableDataSource.TableDataSource(slice);
  }, [slice]);
  var columnDefinitions = (0, React.useMemo)(function () {
    return (0, _ag_translate.transformColumnDefinitionsIntoAgGrid)(columns);
  }, [columns]);
  var handleFilterChanged = (0, React.useCallback)(function (evt) {
    var filters = evt.api.getFilterModel();

    if (isEmptyFilter(filters)) {
      onFilterChanged(undefined, undefined);
    } else {
      var newFilter = (0, _ag_translate.translateAgGridFilter)(filters, columns);

      if (!(0, _lodash.isEqual)(newFilter, filterExpression)) {
        onFilterChanged(newFilter, filters);
      }
    }
  }, [columns, filterExpression, onFilterChanged]);
  var handleOnGridReady = (0, React.useCallback)(function (_ref2) {
    var api = _ref2.api;
    return setApi(api);
  }, []);
  (0, React.useEffect)(function () {
    if (api) {
      var current = api.getFilterModel(); // Clear the existing filter

      if (!isEmptyFilter(current) && !filterExpression) {
        api.setFilterModel(null);
        return;
      } // Update the existing filter


      if (agFilterExpression && !(0, _lodash.isEqual)(current, agFilterExpression)) {
        api.setFilterModel(agFilterExpression);
        return;
      }
    }
  });
  return React.createElement(TableContainer, null, React.createElement(TableTarget, {
    className: "ag-theme-dark"
  }, React.createElement(_agGridReact.AgGridReact, {
    onGridReady: handleOnGridReady,
    onFilterChanged: handleFilterChanged,
    datasource: rowData,
    rowModelType: "infinite",
    columnDefs: columnDefinitions
  })));
});
exports.Grid = Grid;

var TableContainer = _styledComponents.default.div(_templateObject());

var TableTarget = _styledComponents.default.div(_templateObject2());