function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\tdisplay: flex;\n\tflex-direction: row;\n\tmin-height: 25px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */

/* eslint-disable jsx-a11y/no-onchange */
import * as React from 'react';
import { memo } from 'react';
import styled from 'styled-components';
import { SliceType } from 'visual-analytics-components';
import { Dropdown } from './Dropdown';
var SLICE_OPTIONS = [{
  value: SliceType.All,
  name: 'All'
}, {
  value: SliceType.FilteredIn,
  name: 'Filtered-In'
}, {
  value: SliceType.FilteredOut,
  name: 'Filtered-Out'
}, {
  value: SliceType.Selected,
  name: 'Selected'
}, {
  value: SliceType.Highlighted,
  name: 'Highlighted'
}];
var SLICE_VALUES = SLICE_OPTIONS.map(function (s) {
  return s.value;
});
var SLICE_LABELS = SLICE_OPTIONS.map(function (s) {
  return s.name;
});
export var Controls = memo(function Controls(_ref) {
  var tableNames = _ref.tableNames,
      table = _ref.table,
      slice = _ref.slice,
      onTableChanged = _ref.onTableChanged,
      onSliceChanged = _ref.onSliceChanged;
  return React.createElement(ControlsContainer, null, React.createElement(Dropdown, {
    options: tableNames,
    value: table,
    onChange: onTableChanged
  }), React.createElement(Dropdown, {
    options: SLICE_VALUES,
    labels: SLICE_LABELS,
    value: slice,
    onChange: onSliceChanged
  }));
});
var ControlsContainer = styled.div(_templateObject());