function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\twidth: 100%;\n\theight: 100%;\n\tdisplay: flex;\n\tflex-direction: column;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
import * as React from 'react';
import { memo, useState, useCallback, useMemo, useEffect } from 'react';
import { filter } from 'rxjs/operators';
import styled from 'styled-components';
import { SliceType, MessageCreators, MessageTypes } from 'visual-analytics-components';
import { AgFilterStore } from '../util/AgFilterStore';
import { Controls } from './Controls';
import { GlobalStyles } from './GlobalStyles';
import { Grid } from './Grid';
export var Datatable = memo(function Datatable(_ref) {
  var manager = _ref.manager;
  var tableNames = useTableNames(manager);
  var store = useMemo(function () {
    return new AgFilterStore();
  }, []);

  var _useState = useState(SliceType.FilteredIn),
      _useState2 = _slicedToArray(_useState, 2),
      slice = _useState2[0],
      setSlice = _useState2[1];

  var _useState3 = useState(tableNames[0]),
      _useState4 = _slicedToArray(_useState3, 2),
      table = _useState4[0],
      setTable = _useState4[1];

  var filterLocation = useMemo(function () {
    return {
      table: table,
      key: 'datatable'
    };
  }, [table]);
  var dataTable = useTable(manager, table);
  var dataSlice = useMemo(function () {
    return dataTable.slice(slice);
  }, [dataTable, slice]);

  var _useState5 = useState(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      dataVersion = _useState6[0],
      setDataVersion = _useState6[1];

  var _useState7 = useState(function () {
    return dataTable.slice(slice).filter.expressions['datatable'];
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      filterExpression = _useState8[0],
      setFilterExpression = _useState8[1];

  var onFilterChanged = useCallback(function (expr, agExpr) {
    if (expr) {
      store.setFilter(table, slice, agExpr);
      setFilterExpression(expr);
      manager.publish(MessageCreators.Filter.replace(filterLocation, expr, 'Apply Data Filter'));
    } else {
      store.clearFilter(table, slice);
      manager.publish(MessageCreators.Filter.clear(filterLocation, 'Clear Data Filter'));
    }
  }, [filterLocation, manager, slice, store, table]);
  var handleTableChanged = useCallback(function (tableName) {
    console.log('set table', tableName);
    setTable(tableName);
  }, []);
  var handleSliceChanged = useCallback(function (slice) {
    return setSlice(slice);
  }, []);
  var isDataChangeEvent = useCallback(function (evt) {
    return evt.type === MessageTypes.Data.Changed && evt.payload.table === table && evt.payload.slice === slice;
  }, [table, slice]);
  useEffect(function () {
    var subscription = manager.messages.pipe(filter(isDataChangeEvent)).subscribe(function (evt) {
      setFilterExpression(dataTable.slice(slice).filter.expressions['datatable']);
      setDataVersion(evt);
    });
    return function () {
      return subscription.unsubscribe();
    };
  }, [manager, isDataChangeEvent, dataTable, slice]);
  return React.createElement(React.Fragment, null, React.createElement(GlobalStyles, null), React.createElement(Container, null, React.createElement(Controls, {
    tableNames: tableNames,
    table: table,
    slice: slice,
    onTableChanged: handleTableChanged,
    onSliceChanged: handleSliceChanged
  }), React.createElement(Grid, {
    filterExpression: filterExpression,
    agFilterExpression: store.getFilter(table, slice),
    dataVersion: dataVersion,
    columns: dataTable.columns,
    slice: dataSlice,
    onFilterChanged: onFilterChanged
  })));
});

function useTableNames(manager) {
  return useMemo(function () {
    return manager.data.tables;
  }, [manager]);
}

function useTable(manager, name) {
  return useMemo(function () {
    return manager.data.table(name);
  }, [manager, name]);
}

var Container = styled.div(_templateObject());