function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n\theight: 100%;\n\twidth: 100%;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\tflex: 1;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { AgGridReact } from 'ag-grid-react';
import { isEqual } from 'lodash';
import * as React from 'react';
import { memo, useMemo, useEffect, useCallback, useState } from 'react';
import styled from 'styled-components';
import { TableDataSource } from '../TableDataSource';
import { translateAgGridFilter, transformColumnDefinitionsIntoAgGrid } from '../util/ag_translate';

function isEmptyFilter(agFilter) {
  return !agFilter || Object.keys(agFilter).length === 0;
}

export var Grid = memo(function Grid(_ref) {
  var slice = _ref.slice,
      columns = _ref.columns,
      filterExpression = _ref.filterExpression,
      agFilterExpression = _ref.agFilterExpression,
      onFilterChanged = _ref.onFilterChanged;

  var _useState = useState(undefined),
      _useState2 = _slicedToArray(_useState, 2),
      api = _useState2[0],
      setApi = _useState2[1];

  var rowData = useMemo(function () {
    return new TableDataSource(slice);
  }, [slice]);
  var columnDefinitions = useMemo(function () {
    return transformColumnDefinitionsIntoAgGrid(columns);
  }, [columns]);
  var handleFilterChanged = useCallback(function (evt) {
    var filters = evt.api.getFilterModel();

    if (isEmptyFilter(filters)) {
      onFilterChanged(undefined, undefined);
    } else {
      var newFilter = translateAgGridFilter(filters, columns);

      if (!isEqual(newFilter, filterExpression)) {
        onFilterChanged(newFilter, filters);
      }
    }
  }, [columns, filterExpression, onFilterChanged]);
  var handleOnGridReady = useCallback(function (_ref2) {
    var api = _ref2.api;
    return setApi(api);
  }, []);
  useEffect(function () {
    if (api) {
      var current = api.getFilterModel(); // Clear the existing filter

      if (!isEmptyFilter(current) && !filterExpression) {
        api.setFilterModel(null);
        return;
      } // Update the existing filter


      if (agFilterExpression && !isEqual(current, agFilterExpression)) {
        api.setFilterModel(agFilterExpression);
        return;
      }
    }
  });
  return React.createElement(TableContainer, null, React.createElement(TableTarget, {
    className: "ag-theme-dark"
  }, React.createElement(AgGridReact, {
    onGridReady: handleOnGridReady,
    onFilterChanged: handleFilterChanged,
    datasource: rowData,
    rowModelType: "infinite",
    columnDefs: columnDefinitions
  })));
});
var TableContainer = styled.div(_templateObject());
var TableTarget = styled.div(_templateObject2());