export class TableDataSource {
    constructor(slice) {
        this.slice = slice;
    }
    getRows(params) {
        this.doGetRows(params);
    }
    async doGetRows(params) {
        const result = [];
        const tableLength = await this.slice.length();
        let endRow;
        for (let i = params.startRow; i < params.endRow && i < tableLength; ++i) {
            if (i === tableLength - 1) {
                endRow = i;
            }
            const row = await this.slice.get(i);
            if (row)
                result.push(row);
        }
        if (endRow) {
            params.successCallback(result, endRow);
        }
        else {
            params.successCallback(result);
        }
    }
    destroy() {
        // do nothing
    }
}
