/*!
 * Copyright (c) Microsoft. All rights reserved.
 * Licensed under the MIT license. See LICENSE file in the project.
 */
/* eslint-disable jsx-a11y/no-onchange */
import * as React from 'react';
import { memo } from 'react';
import styled from 'styled-components';
import { SliceType } from 'visual-analytics-components';
import { Dropdown } from './Dropdown';
const SLICE_OPTIONS = [
    { value: SliceType.All, name: 'All' },
    { value: SliceType.FilteredIn, name: 'Filtered-In' },
    { value: SliceType.FilteredOut, name: 'Filtered-Out' },
    { value: SliceType.Selected, name: 'Selected' },
    { value: SliceType.Highlighted, name: 'Highlighted' },
];
const SLICE_VALUES = SLICE_OPTIONS.map(s => s.value);
const SLICE_LABELS = SLICE_OPTIONS.map(s => s.name);
export const Controls = memo(function Controls({ tableNames, table, slice, onTableChanged, onSliceChanged, }) {
    return (React.createElement(ControlsContainer, null,
        React.createElement(Dropdown, { options: tableNames, value: table, onChange: onTableChanged }),
        React.createElement(Dropdown, { options: SLICE_VALUES, labels: SLICE_LABELS, value: slice, onChange: onSliceChanged })));
});
const ControlsContainer = styled.div `
	display: flex;
	flex-direction: row;
	min-height: 25px;
`;
