import { useThematic } from '@thematic/react';
import * as React from 'react';
import { memo, useCallback } from 'react';
import styled from 'styled-components';
export const Dropdown = memo(function Dropdown({ value, onChange, options, labels, }) {
    const theme = useThematic();
    const handleChange = useCallback(event => onChange(event.target.value), [
        onChange,
    ]);
    return (React.createElement(SelectorDropdown, { value: value, onChange: handleChange, theme: theme }, options.map((t, index) => (React.createElement("option", { key: t, value: t }, (labels && index < labels.length && labels[index]) || t)))));
});
const SelectorDropdown = styled.select `
	margin-top: 1px;
	margin-bottom: 2px;
	margin-right: 2px;
	color: ${({ theme }) => theme.text().fill().hex()};
	background-color: ${({ theme }) => theme.plotArea().fill().hex()};
`;
